%define module   rtw89

Name:            dkms-%{module}
Version:         main
Release:         %mkrel 1

Summary:         dkms package for %{module} driver
License:         GPLv2
Group:           System/Kernel and hardware
Source0:         https://codeload.github.com/lwfinger/rtw89/zip/refs/heads/%{version}
Source2:         dkms.conf
URL:             https://github.com/lwfinger/rtw89

BuildRequires : make
BuildRequires : gcc
Recommends: dkms-rtw89-bt
Requires: rtlwifi-firmware
Requires: dkms


%description
Provides Realtek Driver for Realtek 8852AE and 8852BE 802.11ax device
Source is https://github.com/lwfinger/rtw89
Blacklist existing kernel module to avoid conflicts

%prep
%setup -q -n rtw89-main

%install
mkdir -p %{buildroot}/%{_usrsrc}/%{module}-%{version}-%{release}/
cp -R * %{buildroot}/%{_usrsrc}/%{module}-%{version}-%{release}/

rm -f -r %{buildroot}/%{_usrsrc}/%{module}-%{version}-%{release}/debian

install -m644 %{SOURCE2} -D %{buildroot}%{_usrsrc}/%{module}-%{version}-%{release}/dkms.conf
mkdir -p %{buildroot}/%{_sysconfdir}/modprobe.d
echo "blacklist rtw89_core" > %{buildroot}/%{_sysconfdir}/modprobe.d/blacklist-rtw89.conf
echo "blacklist rtw89_pci" >> %{buildroot}/%{_sysconfdir}/modprobe.d/blacklist-rtw89.conf
mkdir -p %{buildroot}/lib/firmware/rtw89
#Removing  firmware that conflicts with rtlwifi-firmware package
rm -f rtw8852a_fw.bin
rm -f rtw8852c_fw.bin
install -m644 *.bin -D %{buildroot}/lib/firmware/rtw89/
%files
%{_sysconfdir}/modprobe.d/blacklist-rtw89.conf
/lib/firmware/rtw89/*bin
%{_usrsrc}/%{module}-%{version}-%{release}/*


%post -n dkms-%{module}
%{_sbindir}/dkms add -m %{module} -v %{version}-%{release} --rpm_safe_upgrade
%{_sbindir}/dkms build -m %{module} -v %{version}-%{release} --rpm_safe_upgrade
%{_sbindir}/dkms install -m %{module} -v %{version}-%{release} --rpm_safe_upgrade
exit 0

%preun -n dkms-%{module}
%{_sbindir}/dkms remove -m %{module} -v %{version}-%{release} --rpm_safe_upgrade --all
exit 0
